=== llvm/lib/Target/AArch64/TargetInfo/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_BINARY_DIR}/.. ${CMAKE_CURRENT_SOURCE_DIR}/.. )

add_llvm_library(LLVMAArch64Info
  AArch64TargetInfo.cpp
  )
